{% if scout is not defined %}
    {% set scout = false %}
{% endif %}
{% if hidden is not defined %}
    {% set hidden = false %}
{% endif %}

{% if not hidden %}
    {% macro target_popup( action_id, provoking_id, targets, target_for, text_having, text_missing, close_button = false, big = false, confirm = false ) %}
        <div class="targets" x-target-selection-for="{{ target_for }}">
            {% if targets|length > 0 %}
                <span>{{ text_having }}</span>
                <ul>
                    {% for target in targets %}
                        {# @var item \App\Entity\Item #}
                        <li x-action-id="{{ action_id }}" {% if confirm %}x-action-confirm="1"{% endif%} {% if provoking_id is not null %}x-provoking-id="{{ provoking_id }}"{% endif %} x-target-id="{{ target[0] }}" >
                            {% if big %}
                                <div><img src="{{ asset(target[2]) }}" alt="{{ target[1] }}"> {{ target[1] }}</div>
                            {% else %}
                                <img src="{{ asset(target[2]) }}" alt="{{ target[1] }}">
                            {% endif %}

                        </li>
                    {% endfor %}
                </ul>
            {% else %}
                <span>{{ text_missing }}</span>
            {% endif %}
            {% if close_button %}
                <div class="right"><span x-close-for="{{ target_for }}">{{ 'Schließen'|trans({},'global') }}</span></div>
            {% endif %}
        </div>
    {% endmacro %}

    {% if (item_action_list is defined and item_action_list|length > 0) or (recipe_list is defined and recipe_list.recipes|length > 0)  %}
        <ul class="actions">
            {% if (item_action_list is defined) %}
                {% for entry in item_action_list %}
                    <li class="action" {% if entry.crossed %}disabled{% elseif entry.targets is null %}x-action-id="{{ entry.id }}" {% if entry.action.confirm %}x-action-confirm="1"{% endif %} x-provoking-id="{{ entry.item.id }}"{% else %}x-target-definition="{{ entry.id }}--{{ entry.item.id }}"{% endif %}>
                        <img src="{{ asset('build/images/item/item_' ~ entry.item.prototype.icon ~ '.gif') }}" alt="{{ entry.item.prototype.label|trans({},'items') }}">
                        {% if scout and entry.action.keepsCover %}
                            <img class="float-right" src="{{ asset('build/images/icons/small_stealthy.gif') }}" alt="">
                        {% endif %}
                        <span>{{ '%action%: %item%'|trans({'%action%': entry.action.label|trans({},'items')|e('html'), '%item%': '<b>' ~ entry.item.prototype.label|trans({},'items')|e('html') ~ '</b>'},'items')|raw }}</span>
                        {% if entry.targets is not null and not entry.crossed %}
                            {% if entry.target_mode == 2 %}
                                {{ _self.target_popup( entry.id, entry.item.id, entry.targets, entry.id ~ '--' ~ entry.item.id, 'Bitte wähle einen Bürger:'|trans({},'game'), 'Es ist kein Bürger in der Nähe...'|trans({},'game'), true, true, entry.action.confirm ) }}
                            {% else %}
                                {{ _self.target_popup( entry.id, entry.item.id, entry.targets, entry.id ~ '--' ~ entry.item.id, 'Bitte wähle einen Gegenstand:'|trans({},'game'), 'Du verfügst über keine geeigneten Gegenstände'|trans({},'game'), true, false, entry.action.confirm ) }}
                            {% endif %}
                        {% endif %}
                    </li>
                {% endfor %}
            {% endif %}
            {% if recipe_list is defined %}
                {% for recipe in recipe_list.recipes %}
                    <li class="action" x-recipe-id="{{ recipe.id }}">
                        {# @var recipe \App\Entity\Recipe #}
                        {% if recipe.result.entries.count == 1 %}
                            {#{% if scout %}
                                <img class="float-right" src="{{ asset('build/images/icons/uncloak.gif') }}" alt="">
                            {% endif %}#}
                            {% if recipe.source and not conf.get(constant('App\\Structures\\TownConf::CONF_MODIFIER_PRE_ASSEMBLY'),false) %}
                                <span>{{ 'Zusammenbauen'|trans({},'game') }}:
                                    {% for entry in recipe.source.entries %}
                                        {# @var entry \App\Entity\ItemGroupEntry #}
                                        {% for n in 1..entry.chance %}
                                            <img class="{% if n > recipe_list.source_items[entry.prototype.id] %}unavailable{% endif %}" src="{{ asset('build/images/item/item_' ~ entry.prototype.icon ~ '.gif') }}" alt="{{ entry.prototype.label|trans({},'items') }}">
                                        {% endfor %}
                                    {% endfor %}
                                </span>
                            {% else %}
                                <img src="{{ asset('build/images/item/item_' ~ recipe.result.entries[0].prototype.icon ~ '.gif') }}" alt="{{ recipe.result.entries[0].prototype.label|trans({},'items') }}">
                                <span>{{ 'Herstellen'|trans({},'game') }}: <b>{{ recipe.result.entries[0].prototype.label|trans({},'items') }}</b></span>
                                {% if recipe.source %}
                                    <span>
                                    {{ 'aus'|trans({},'game') }}:
                                    {% for entry in recipe.source.entries %}
                                        {# @var entry \App\Entity\ItemGroupEntry #}
                                        {% for n in 1..entry.chance %}
                                            <img class="{% if n > recipe_list.source_items[entry.prototype.id] %}unavailable{% endif %}" src="{{ asset('build/images/item/item_' ~ entry.prototype.icon ~ '.gif') }}" alt="{{ entry.prototype.label|trans({},'items') }}">
                                        {% endfor %}
                                    {% endfor %}
                                </span>
                                {% endif %}
                            {% endif %}

                        {% else %}
                            {% if recipe.source %}
                                {% if scout %}
                                    <img class="float-right" src="{{ asset('build/images/icons/uncloak.gif') }}" alt="">
                                {% endif %}
                                <span>
                                    {{ 'Kombinieren'|trans({},'game') }}:
                                    {% for entry in recipe.source.entries %}
                                        {# @var entry \App\Entity\ItemGroupEntry #}
                                        {% for n in 1..entry.chance %}
                                            <img class="{% if n > recipe_list.source_items[entry.prototype.id] %}unavailable{% endif %}" src="{{ asset('build/images/item/item_' ~ entry.prototype.icon ~ '.gif') }}" alt="{{ entry.prototype.label|trans({},'items') }}">
                                        {% endfor %}
                                    {% endfor %}
                                </span>
                            {% endif %}
                        {% endif %}
                    </li>
                {% endfor %}
            {% endif %}
        </ul>
    {% endif %}

    {% if special_action_list is defined and special_action_list|length > 0 %}
        <ul class="special_actions">
            {% for entry in special_action_list %}
                <li class="heroic_action" {% if entry.crossed %}disabled{% elseif entry.targets is null %}x-action-id="{{ entry.id }}" {% if entry.action.confirm %}x-action-confirm="1"{% endif %} {% else %}x-target-definition="{{ entry.id }}--special"{% endif %}>
                    <img src="{{ asset('build/images/actions/' ~ entry.icon ~ '.gif') }}" alt="">
                    <span>
                        <b>
                            {{ entry.action.label|trans({},'items') }}
                            {% if entry.action.results|length > 0 %}
                                {% set ap = 0 %}
                                {% for result in entry.action.results %}
                                    {% if not result.ap is null %}
                                        {% set ap = ap + result.ap.ap|abs %}
                                    {% endif %}
                                {% endfor %}
                                {% if ap > 0 %}
                                    ({{ap}} <div class="ap"></div>)
                                {% endif %}
                            {% endif %}
                        </b>
                    </span>
                    {% if entry.targets is not null and not entry.crossed %}
                        {% if entry.target_mode == 2 %}
                            {{ _self.target_popup( entry.id, null, entry.targets, entry.id ~ '--special', 'Bitte wähle einen Bürger:'|trans({},'game'), 'Es ist kein Bürger in der Nähe...'|trans({},'game'), true, true, entry.action.confirm ) }}
                        {% else %}
                            {{ _self.target_popup( entry.id, null, entry.targets, entry.id ~ '--special', 'Bitte wähle einen Gegenstand:'|trans({},'game'), 'Du verfügst über keine geeigneten Gegenstände'|trans({},'game'), true, false, entry.action.confirm ) }}
                        {% endif %}
                    {% endif %}
                </li>
            {% endfor %}
        </ul>

    {% endif %}

    {% if heroic_action_list is defined and heroic_action_list|length > 0 %}
        <button x-heroic-toggle="1"><img src="{{ asset('build/images/icons/star.gif') }}" alt="">{{ 'Heldentaten'|trans({},'items')  }}</button>
        <ul class="heroic_actions">
            {% for entry in heroic_action_list %}
                <li class="heroic_action" {% if entry.crossed %}disabled{% elseif entry.targets is null %}x-action-id="{{ entry.id }}" x-action-confirm="1" {% else %}x-target-definition="{{ entry.id }}--hero"{% endif %}>
                    <img src="{{ asset('build/images/icons/star.gif') }}" alt="">
                    {% if scout and entry.action.keepsCover %}
                        <img class="float-right" src="{{ asset('build/images/icons/small_stealthy.gif') }}" alt="">
                    {% endif %}
                    <span><b>{{ entry.action.label|trans({},'items') }}</b></span>
                    {% if entry.targets is not null and not entry.crossed %}
                        {% if entry.target_mode == 2 %}
                            {{ _self.target_popup( entry.id, null, entry.targets, entry.id ~ '--hero', 'Bitte wähle einen Bürger:'|trans({},'game'), 'Es ist kein Bürger in der Nähe...'|trans({},'game'), true, true, entry.action.confirm ) }}
                        {% else %}
                            {{ _self.target_popup( entry.id, null, entry.targets, entry.id ~ '--hero', 'Bitte wähle einen Gegenstand:'|trans({},'game'), 'Du verfügst über keine geeigneten Gegenstände'|trans({},'game'), true, false, entry.action.confirm ) }}
                        {% endif %}
                    {% endif %}
                </li>
            {% endfor %}
            <li><div class="right pointer small" x-heroic-toggle="0">{{ 'Schließen'|trans({},'global') }}</div></li>
        </ul>

    {% endif %}
{% else %}
    <ul class="actions">
        <li>{{ 'Du kannst keine Aktionen ausführen, während du dich versteckst.'|trans({},'game')  }}</li>
    </ul>
{% endif %}